VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5400
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6855
   LinkTopic       =   "Form1"
   ScaleHeight     =   5400
   ScaleWidth      =   6855
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   4095
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   240
      Width           =   6495
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   200
      Left            =   3120
      Top             =   4680
   End
   Begin VB.CommandButton butConfigure 
      Caption         =   "Configure"
      Height          =   615
      Left            =   5160
      TabIndex        =   1
      Top             =   4560
      Width           =   1575
   End
   Begin VB.CommandButton butTest 
      Caption         =   "Test"
      Height          =   615
      Left            =   120
      TabIndex        =   0
      Top             =   4560
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private PluginArray() As New JukePlugin

Private Function StringEndsWith(ByVal StrValue As String, CheckFor As String, Optional CompareType As VbCompareMethod = vbBinaryCompare) As Boolean
  Dim sCompare As String
  Dim lLen As Long
   
  lLen = Len(CheckFor)
  If lLen > Len(StrValue) Then Exit Function
  sCompare = Right(StrValue, lLen)
  StringEndsWith = StrComp(sCompare, CheckFor, CompareType) = 0
End Function

Private Function GetPluginList(ByVal Path As String) As String()
    Dim FileName As String
    Dim FileList() As String
    
    FileName = Dir(Path)
    While FileName <> Empty
        If StringEndsWith(FileName, ".jps", vbTextCompare) Then
            If (Not FileList) = True Then
                ReDim FileList(1)
            Else
                ReDim Preserve FileList(UBound(FileList, 1) + 1)
            End If
    
            FileList(UBound(FileList, 1) - 1) = FileName
        End If
        FileName = Dir
    Wend

    GetPluginList = FileList
End Function

Private Function GetPluginArray() As Boolean
    Dim PluginList() As String
    
    PluginList = GetPluginList(App.Path & "\Plugins\")
    
    If (Not PluginList) = True Then
        GetPluginArray = False
        Exit Function
    End If
    
    ReDim PluginArray(UBound(PluginList, 1))
    
    Dim I As Integer
    
    For I = 0 To UBound(PluginList, 1) - 1
        Dim RetVal As Long
        RetVal = PluginArray(I).Initialize(Me.hDC, "Plugins\" & PluginList(I))
    Next
    
    GetPluginArray = True
End Function

Private Sub butTest_Click()
    If (Not PluginArray) = True Then
        Exit Sub
    End If
    
    Dim I As Integer
    
    For I = 0 To UBound(PluginArray, 1) - 1
        Dim RetVal() As String
        
        MsgBox PluginArray(I).Name & "," & PluginArray(I).Author & "," & PluginArray(I).Version & "," & PluginArray(I).Description, vbOKOnly, "Juke_GetPluginInfo"
        
        RetVal = PluginArray(I).VolumeChange("Test", 10, 0, 100)
        
        MsgBox Join(RetVal, "|")
        
        RetVal = PluginArray(I).PluginEventCreate("Test2", "ENABLE DISABLE KEYDOWN KEYUP KEYCLICK")
        
        MsgBox Join(RetVal, "|")
    Next
End Sub

Private Sub butConfigure_Click()
    If (Not PluginArray) = True Then
        Exit Sub
    End If
    
    If UBound(PluginArray, 1) + 1 > 0 Then
        PluginArray(0).Configure Me.hwnd
    End If
End Sub

Private Sub Form_Load()
    GetPluginArray
    'Timer1.Enabled = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    'Timer1.Enabled = False
    
    If (Not PluginArray) = True Then
        Exit Sub
    End If
    
    Dim I As Integer
    
    For I = 0 To UBound(PluginArray, 1) - 1
        Dim RetVal As Long
        RetVal = PluginArray(I).Shutdown
    Next
End Sub

Private Sub Timer1_Timer()
    If (Not PluginArray) = True Then
        Exit Sub
    End If
    
    Dim I As Integer
    
    For I = 0 To UBound(PluginArray, 1) - 1
        Dim RetVal() As String
        RetVal = PluginArray(I).PluginEventGet()
        
        If UBound(RetVal, 1) + 1 = 2 Then
            Select Case RetVal(0)
                Case "PLUGIN_EVENT_KEYDOWN"
                    Text1.Text = Text1.Text & "PLUGIN_EVENT_KEYDOWN:" & RetVal(1) & vbNewLine
                    Text1.SelStart = Len(Text1.Text)
            End Select
        End If
    Next
End Sub
